Redisson is the Java Client and Real-Time Data Platform for [Redis](https://redis.io) or [Valkey](https://valkey.io). Providing the most convenient and easiest way to work with Redis or Valkey. Redisson objects provide an abstraction layer between Redis or Valkey and your Java code, which allowing maintain focus on data modeling and application logic.

Redisson is compatible with the following Redis and Valkey cloud providers:

* [AWS ElastiCache](https://docs.aws.amazon.com/AmazonElastiCache/latest/UserGuide/Replication.html)  
* [AWS ElastiCache Cluster](https://docs.aws.amazon.com/AmazonElastiCache/latest/UserGuide/Clusters.html)  
* [Azure Redis Cache](https://azure.microsoft.com/en-us/services/cache/)  
* [Google Cloud Memorystore for Redis](https://cloud.google.com/memorystore/docs/redis/)  
* [HUAWEI Distributed Cache Service for Redis](https://www.huaweicloud.com/en-us/product/dcs.html)  
* [Aiven Redis hosting](https://aiven.io/redis)
* [RLEC Multiple Active Proxy](https://docs.redislabs.com/latest/rs/administering/designing-production/networking/multiple-active-proxy/)
* and many others.

Use the [Redis or Valkey commands mapping](commands-mapping.md) table to find the Redisson method for a particular Redis or Valkey command.

Redisson is Based on the [Netty](http://netty.io/) framework and is [Redis](http://redis.io) 3.0+ and JDK 1.8+ compatible.

Try __[Redisson PRO](https://redisson.pro)__ with **advanced features** and **support by SLA**.